/*
 *   Copyright 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spago4Q.

    Spago4Q is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published 
    by the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spago4Q is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package it.eng.configurazione.test;

import org.hibernate.Session;

import it.eng.configurazione.bean.Interface;
import it.eng.configurazione.service.ConfigurationDAO;
import it.eng.configurazione.service.HibernateUtils;
import junit.framework.TestCase;

public class InterfaceTest extends TestCase {

	Interface interfacciaTest=null;
	Session sessione= HibernateUtils.getSession();
	public InterfaceTest(String name) {
		super(name);
		
	}

	protected void setUp() throws Exception {
		
		

		interfacciaTest=new Interface();
		interfacciaTest.setClassforname("it.eng.test.managerImpl.class");
		interfacciaTest.setName("Interfaccia_Requisiti");
		interfacciaTest.setDescription("Questa interfaccia definisce tutti i campi dei requisiti");
		interfacciaTest.setXmlSchema("");
		
		sessione.beginTransaction();
		sessione.save(interfacciaTest);
		sessione.getTransaction().commit();
	}

	protected void tearDown() throws Exception {

		sessione.beginTransaction();
		sessione.delete(interfacciaTest);
		sessione.getTransaction().commit();		
	}

	/**
	 * test di lettura della configurazione
	 *
	 */
	public void testLetturaInterfaccia() {
		ConfigurationDAO dao=new ConfigurationDAO();
		Interface interfaccia=dao.readInterface("Interfaccia_Requisiti");
		assertEquals(interfaccia.getName(), interfacciaTest.getName());
		assertEquals(interfaccia.getDescription(), interfacciaTest.getDescription());
		assertEquals(interfaccia.getClassforname(), interfacciaTest.getClassforname());
		assertEquals(interfaccia.getId(), interfacciaTest.getId());
		assertEquals(interfaccia.getXmlSchema(), interfacciaTest.getXmlSchema());
		
	}

}
